print "Content-Type: text/html"
print

#PATTERN COACHES
from pattern.en import sentiment, modality, parse, Sentence
import json
from math import floor
from random import randint
import portraits
import urllib2

coaches = json.load(open('personalities.json'))

choices = []
index = 1
for key in coaches:
  choices.append(key)
  #print '{} - {}'.format(index, key)
  index = index+1
#title, #description of coach
#You have chosen the {} coach!
#print portrait
#choice = choices[int(raw_input())-1]

#print 'You have chosen to write a {}'.format(choice)

#print coaches[choice]['description']

docfile = 'coach-approved.txt'
#print 'Where would you like to save your {}?'.format(choice)
#docfile = raw_input()

class Coach:
  coach_type = ''
  coach_description = ''
  coach_types = []
  coach_responses = []
  doc = ''
  url = ''

  def __init__(self, docfile, coach_type, coach_description, coach_types,  coach_responses):
    self.coach_type = coach_type
    self.coach_description = coach_description
    self.coach_types = coach_types
    self.coach_responses = coach_responses
    self.docfile = docfile
    self.doc  = self.docfile
    self.url = 'http://10.1.10.1/lastline'

  def getInput(self):    
    return raw_input()

  def getWebInput(self):
    return str(urllib2.urlopen(self.url).read())

  def getSubjectivity(self, text):
    p = parse(text, tokenize=True, lemmata=True)
    return sentiment(Sentence(p))[1] #does sentence() make a difference?

  def getPolarity(self, text):
    p = parse(text, tokenize=True, lemmata=True)
    return sentiment(Sentence(p))[0]

  def getModality(self, text):
    p = parse(text, tokenize=True, lemmata=True)
    return modality(Sentence(p))

  def getMood(self, test):
    p = parse(text, tokenize=True, lemmata=True)
    return mood(Sentence(p))

  def calcResponseStrength(self, paramVal):
    return floor( paramVal*(len(self.coach_responses)+1)/2 )

  def mapValues(self, value, leftMin, leftMax, rightMin, rightMax):
    leftSpan = leftMax - leftMin
    rightSpan = rightMax - rightMin
    valueScaled = float(value - leftMin) / float(leftSpan)
    return rightMin + (valueScaled * rightSpan)

  def diaryCoach(self, txt):
    subj = self.getSubjectivity(txt)
    res = int(self.mapValues(subj, 0, 1, 0, len(self.coach_responses)-1))
    if res > 0.5:
      self.doc.write(txt)
    return self.talkingHead(), self.coach_description, txt, ('Subjectivity: ' + str(subj)), self.coach_responses[res]

  def complaintCoach(self, txt):
    pol = self.getPolarity(txt)
    res = int(self.mapValues(pol, -1, 1, len(self.coach_responses)-1, 0))
    if res > 0:
      self.doc.write(txt)
    return self.talkingHead(), self.coach_description, txt, ('Polarity: ' + str(pol)), self.coach_responses[res]

  def loveCoach(self, txt):
    pol = self.getPolarity(txt)
    res = int(self.mapValues(pol, -1, 1, 0, len(self.coach_responses)-1))
    if res > 0 :
      self.doc.write(txt)
    return self.talkingHead(), self.coach_description, txt, ('Polarity: ' + str(pol)), self.coach_responses[res]

  def wikiCoach(self, txt):
    subj = self.getSubjectivity(txt)
    res = int(self.mapValues(subj, 0, 1, len(self.coach_responses)-1, 0))
    if res > 0.5:
      self.doc.write(txt)
    return self.talkingHead(), self.coach_description, txt, ('Subjectivity: ' + str(subj)), self.coach_responses[res]

  def criticCoach(self, txt):
    mod = self.getModality(txt)
    res = int(self.mapValues(mod, -1, 1, len(self.coach_responses)-1, 0))
    if res > 0:
      self.doc.write(txt)
    return self.talkingHead(), self.coach_description, txt, ('Modality: ' + str(mod)), self.coach_responses[res]

  def talkingHead(self):
    return portraits.portraits[self.coach_type]

  def activate(self):
    userInput = self.getWebInput()
    if(userInput == '/exit'):
      exit()
    if self.coach_type == self.coach_types[0]:
      return self.diaryCoach(userInput)
    elif self.coach_type == self.coach_types[1]:
      return self.complaintCoach(userInput)
    elif self.coach_type == self.coach_types[2]:
      return self.loveCoach(userInput)
    elif self.coach_type == self.coach_types[4]:
      return self.criticCoach(userInput)
    elif self.coach_type == self.coach_types[3]:
      return self.wikiCoach(userInput)
    else:
      return "I don't know what to believe"
      exit()

  def commit(self, text):
    doc.write(text)

  def escape(self):
    self.docfile.close()
    exit()
    coaches.close()

doc = open(docfile, 'w')

wiki = Coach(doc, 'Wikipedia_Article', coaches['Wikipedia_Article']['description'], choices, coaches['Wikipedia_Article']['responses'])
love = Coach(doc, 'Love_Letter', coaches['Love_Letter']['description'], choices, coaches['Love_Letter']['responses'])
complaint = Coach(doc, 'Complaint', coaches['Complaint']['description'], choices, coaches['Complaint']['responses'])
diary = Coach(doc, 'Diary', coaches['Diary']['description'], choices, coaches['Diary']['responses'])
critic = Coach(doc, 'Critical_Analysis', coaches['Critical_Analysis']['description'], choices, coaches['Critical_Analysis']['responses'])

result = []
randchoice = randint(0, 4)
if randchoice == 0:
  result = wiki.activate()
elif randchoice == 1:
  result = love.activate()
elif randchoice == 2:
  result = diary.activate()
else:
  result = critic.activate()


print """
<html>
<head>
  <title>Pattern Writing Coach</title>
  <style type="text/css">
    body {
      background-color: #222;
      color: #fff;
      font-size: 18px;
      font-family: "Lucida Console", Monaco, monospace;
    }
    #title {
      margin-left: 10%;
    }
    #portrait {
      float: left;
      width: 50%;
    }
    #text {
      margin-top: 50px;
      float: right;
      width: 50%;
    }
  </style>
</head>
<body>
"""
print"""
<pre id="title">
___  ____ ___ ___ ____ ____ _  _    _ _ _ ____ _ ___ _ _  _ ____    ____ ____ ____ ____ _  _ 
|__] |__|  |   |  |___ |__/ |\ |    | | | |__/ |  |  | |\ | | __    |    |  | |__| |    |__| 
|    |  |  |   |  |___ |  \ | \|    |_|_| |  \ |  |  | | \| |__]    |___ |__| |  | |___ |  | 
                                                                                             
 
</pre>

<pre id='portrait'>
{} 
{}
</pre>

<div id="text">
<p>
YOU SAID: "{}"
</br></br>
{}
</br></br>
{}
</p>
</div>

</body>
</html>""".format(result[0], result[1], result[2], result[3], result[4])
